<template>
  <div class="hello m-4">
    <b-row>
      <b-col md="3">
        <p class="mb-4">Calculator A</p>
        <b-card class="p-4" style="height: 100% !important">
          <b-row
            md="12"
            class="pl-4 pr-4"
            style="font-size: 30px; border-block-end: 1px solid #dadada"
          >
            <div style="height: 100% !important">{{ displayA1 }}</div>
          </b-row>
          <b-row md="12" class="pl-4 pr-4">
            <div style="height: 100% !important">{{ displayA2 }}</div>
          </b-row>
          <b-row>
            <table style="width: 100%">
              <tr>
                <td @click="clearA()">C</td>
                <td @click="keyA('*')">X</td>
                <td @click="keyA('-')">-</td>
                <td rowspan="2" @click="keyA('+')">+</td>
              </tr>
              <tr>
                <td @click="keyA(7)">7</td>
                <td @click="keyA(8)">8</td>
                <td @click="keyA(9)">9</td>
              </tr>
              <tr>
                <td @click="keyA(4)">4</td>
                <td @click="keyA(5)">5</td>
                <td @click="keyA(6)">6</td>
                <td rowspan="3" @click="equalA()">=</td>
              </tr>
              <tr>
                <td @click="keyA(1)">1</td>
                <td @click="keyA(2)">2</td>
                <td @click="keyA(3)">3</td>
              </tr>
              <tr>
                <td colspan="2" @click="keyA(0)">0</td>
                <td @click="keyA('.')">.</td>
              </tr>
            </table>
          </b-row>
        </b-card>
      </b-col>
      <b-col md="3">
        <p class="mb-4">Calculator B</p>
        <b-card class="p-4" style="height: 100% !important">
          <b-row
            md="12"
            class="pl-4 pr-4"
            style="font-size: 30px; border-block-end: 1px solid #dadada"
          >
            <span>{{ displayB1 }}</span>
          </b-row>
          <b-row md="12" class="pl-4 pr-4">
            <span>{{ displayB2 }}</span>
          </b-row>
          <b-row>
            <table style="width: 100%">
              <tr>
                <td @click="clearB()">C</td>
                <td @click="keyB('*')">X</td>
                <td @click="keyB('-')">-</td>
                <td rowspan="2" @click="keyB('+')">+</td>
              </tr>
              <tr>
                <td @click="keyB(7)">7</td>
                <td @click="keyB(8)">8</td>
                <td @click="keyB(9)">9</td>
              </tr>
              <tr>
                <td @click="keyB(4)">4</td>
                <td @click="keyB(5)">5</td>
                <td @click="keyB(6)">6</td>
                <td rowspan="3" @click="equalB()">=</td>
              </tr>
              <tr>
                <td @click="keyB(1)">1</td>
                <td @click="keyB(2)">2</td>
                <td @click="keyB(3)">3</td>
              </tr>
              <tr>
                <td colspan="2" @click="keyB(0)">0</td>
                <td @click="keyB('.')">.</td>
              </tr>
            </table>
          </b-row>
        </b-card>
      </b-col>
      <b-col md="6">
        <b-row class="mb-2">
          <b-col md="2"> Result </b-col>
          <b-col md="6">
            <b-input
              style="
                border-radius: 20px;
                box-shadow: 0 2px 3px 0 rgba(0, 0, 0, 0.2);
              "
              v-model="filter"
              type="search"
              placeholder="Search by result, date"
            ></b-input>
          </b-col>
          <b-col md="4">
            <b-select
              style="
                border-radius: 20px;
                box-shadow: 0 2px 3px 0 rgba(0, 0, 0, 0.2);
              "
              v-model="filterSelect"
              @change="selected(filterSelect)"
            >
            <b-select-option value="">All
            </b-select-option>
            <b-select-option value="A">A
            </b-select-option>
            <b-select-option value="B">B
            </b-select-option>
            </b-select>
          </b-col>
        </b-row>
        <b-card class="p-4 scroll" style="height: 100% !important">
          <b-table
            :filter="filter"
            striped
            hover
            :items="history"
          >
          <template #cell(date)="row">
        {{ moment(row.item.date).format("DD/MM/YYYY - HH:mm:ss")}}
      </template>
            <template #table-caption
              ><b-button
                class="mt-2"
                style="float: right"
                @click="clearHistory()"
                v-if="history.length"
                variant="danger"
                >Clear</b-button
              ></template
            >
          </b-table>

          <!-- <div v-for="(item, idx) of history" v-bind:key="idx">
            <br />
            <div style="display: inline">
              <span style="float: left">
                {{ item.calculator }}
              </span>
              <span style="float: right">
                {{ moment(item.date).format("DD/MM/YYYY - HH:mm:ss") }}
              </span>
            </div>
            <br />
            <div>
              <span style="float: left">
                {{ item.result1 }}
              </span>
            </div>
            <br />
            <div style="border-block-end: 1px solid #dadada">
              <span style="float: left">
                {{ item.result2 }}
              </span>
            </div>
          </div> -->
        </b-card>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import moment from "moment";
export default {
  name: "HelloWorld",
  props: {
    msg: String,
  },
  data() {
    return {
      moment,
      displayA1: "",
      displayA2: "",
      displayB1: "",
      displayB2: "",
      calculator: "",
      filter: "",
      filterSelect: "",
      history: [],
      history2: [],
      fields: [
        { key: "result1", sortable: true },
        { key: "result2", sortable: true },
        { key: "calculator", sortable: true},
        { key: "date", sortable: true },
      ],
    };
  },
  computed: {},
  async created() {},
  methods: {
    clearA() {
      this.displayA1 = "";
      this.displayA2 = "";
    },
    clearB() {
      this.displayB1 = "";
      this.displayB2 = "";
    },
    keyA(num) {
      return (this.displayA2 += num);
    },
    keyB(num) {
      return (this.displayB2 += num);
    },
    equalA() {
      let equal = this.displayA2;
      this.displayA1 = eval(equal);
      this.calculator = "A";
      this.history.push({
        result1: this.displayA1,
        result2: this.displayA2,
        calculator: this.calculator,
        date: new Date(),
      });
      this.history2 = this.history
    },
    equalB() {
      let equal = this.displayB2;
      this.displayB1 = eval(equal);
      this.calculator = "B";
      this.history.push({
        result1: this.displayB1,
        result2: this.displayB2,
        calculator: this.calculator,
        date: new Date(),
      });
      this.history2 = this.history
    },
    clearHistory() {
      if (confirm('Are you sure to clear data?')) {
        this.history = [];
        this.history2 = [];
      }
    },
    selected(cal) {
      if (cal !== "") {
      this.history = this.history2
      this.history = this.history.filter(x => x.calculator === `${cal}`)
      } else {
        this.history = this.history2
      }
    }
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
td:active {
  background: rgb(190, 190, 190) !important;
}
td {
  background-color: #a5d8fa;
  padding: 10px;
  margin: 10px;
  cursor: pointer;
  border: 7px solid rgb(255, 255, 255);
  border-radius: 1rem;
}
.card {
  border-radius: 1rem !important;
  border-color: none;
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
}
.scroll {
  max-height: 400px;
  overflow-y: auto;
}
span {
  border-bottom: 10px;
}

.equal-sign {
  background-color: hsl(120, 100%, 25%);
  height: 133px;
}
</style>
